local M = {}
local onetime = 1
local onetime2 = 1
local timer = 0

engineRunning = true
engineBroken = false

local function init()
end

local function onInit()
	for k, node in pairs (v.data.nodes) do
		if node.name == "prlr7r" then pr_r_1=k
		elseif node.name == "prlr8r" then pr_r_2=k
		elseif node.name == "prlr9r" then pr_r_3=k
		elseif node.name == "prlr10r" then pr_r_4=k
		elseif node.name == "prlr7l" then pr_l_1=k
		elseif node.name == "prlr8l" then pr_l_2=k
		elseif node.name == "prlr9l" then pr_l_3=k
		elseif node.name == "prlr10l" then pr_l_4=k
		elseif node.name == "fub26" then bnode1=k
		elseif node.name == "fub22l" then bnode2=k
		end
	end
	engineBroken = false
	engineRunning = true
end

local function update(dt)
	if onetime == 1 then onInit() onetime = 0 end
	for i = 0, tableSizeC(v.data.beams) - 1 do
		local beam = v.data.beams[i]
		if string.find(tostring(beam.name), "EngineDamage") ~= nil and obj:beamIsBroken(beam.cid) then gui.message("Engine broken") engineBroken = true end
	end
	if engineBroken then
		electrics.values.engine_sound = 0
	else
		if engineRunning and v.data.engine then
			electrics.values['cust_throttle'] = electrics.values['cust_throttle'] + (electrics.values.chng_throttle * dt * 30)
			if electrics.values['cust_throttle'] > 100 then electrics.values['cust_throttle'] = 100 elseif electrics.values['cust_throttle'] < 0 then electrics.values['cust_throttle'] = 0 end
			obj:applyForce(pr_r_1, pr_r_2, 75+electrics.values['cust_throttle']*50)
			obj:applyForce(pr_r_3, pr_r_4, 75+electrics.values['cust_throttle']*50)
			obj:applyForce(pr_l_1, pr_l_2, 75+electrics.values['cust_throttle']*50)
			obj:applyForce(pr_l_3, pr_l_4, 75+electrics.values['cust_throttle']*50)
			electrics.values.engine_sound = math.max(15, electrics.values.wheelspeed*1.35)
			if onetime2 == 0 then gui.message("Engine turned on") onetime2 = 1 end
			if electrics.values.chng_throttle ~= 0 then if timer > 0.025 then gui.message(string.format("Throttle: %d%%", electrics.values['cust_throttle'])) timer = 0 else timer = timer + dt end end
		else if onetime2 == 1 then gui.message("Engine turned off") onetime2 = 0 end electrics.values.engine_sound = electrics.values.wheelspeed*1.35
		end
		if electrics.values.tgl_engine == 1 then engineRunning = not engineRunning electrics.values.tgl_engine = 0 end
	end
	if electrics.values['cuban_brake'] > 0 and electrics.values.airspeed > 1 then obj:applyForce(bnode1, bnode2, electrics.values['cuban_brake']*6000) end
end

local function reset()
	onInit()
end

M.reset     = reset
M.init		= init
M.onInit	= onInit
M.update 	= update
thrusters.update = update

return M